#include <iostream>
#include <vector>
#include <algorithm>
#include <limits.h>
using namespace std;

typedef long long ll;

ll n,k;
ll r[1000000];
int p[1000000];

bool moving = true;

void init()
{
    scanf("%lld%lld",&n,&k);
    for(int i=0;i<n;i++)
    {
        scanf("%lld",&r[i]);
    }
    sort(r,r+n);

    p[0]=-1;
    for(int i=1;i<k;i++)
        p[i]=(n/k)*i;
    p[k]=n-1;
}

void slideP()
{
    for(int i=1;i<k;i++)
    {
        ll c = (p[i]-p[i-1]) * r[p[i]] + (p[i+1]-p[i]) * r[p[i+1]];

        while(p[i]-1>p[i-1]&&c>(p[i]-1-p[i-1]) * r[p[i]-1] + (p[i+1]-p[i]+1) * r[p[i+1]])
        {
            c = (p[i]-1-p[i-1]) * r[p[i]-1] + (p[i+1]-p[i]+1) * r[p[i+1]];
            p[i]--;
            moving = true;
        }

        while(p[i+1]>p[i]+1&&c>=(p[i]-p[i-1]+1)*r[p[i]+1]+(p[i+1]-p[i]-1)*r[p[i+1]])
        {
            c=(p[i]-p[i-1]+1)*r[p[i]+1]+(p[i+1]-p[i]-1)*r[p[i+1]];
            p[i]++;
            moving = true;
        }
    }
}

void PSlide()
{
    for(int i=k;i>0;i--)
    {
        ll c = (p[i]-p[i-1]) * r[p[i]] + (p[i+1]-p[i]) * r[p[i+1]];

        while(p[i]-1>p[i-1]&&c>(p[i]-1-p[i-1]) * r[p[i]-1] + (p[i+1]-p[i]+1) * r[p[i+1]])
        {
            c = (p[i]-1-p[i-1]) * r[p[i]-1] + (p[i+1]-p[i]+1) * r[p[i+1]];
            p[i]--;
            moving = true;
        }

        while(p[i+1]>p[i]+1&&c>=(p[i]-p[i-1]+1)*r[p[i]+1]+(p[i+1]-p[i]-1)*r[p[i+1]])
        {
            c=(p[i]-p[i-1]+1)*r[p[i]+1]+(p[i+1]-p[i]-1)*r[p[i+1]];
            p[i]++;
            moving = true;
        }
    }
}

int main()
{
    init();

    while(moving)
    {
        slideP();
        PSlide();
        moving = false;
    }

    ll ans=0;
    for(int i=1;i<=k;i++)
    {
        ans+=(p[i]-p[i-1])*r[p[i]];
        cout<<(p[i]-p[i-1])*r[p[i]]<<endl;
    }

    cout<<ans<<endl;

    for(int i=0;i<=k;i++)
        cout<<p[i]<<" ";
    cout<<endl;
}
/*
10 4
4 1 12 17 7 3 6 8 10 16

8 3
1 3 5 7 8 10 15 21

8 5
1 3 5 7 8 10 15 21
*/