#include<bits/stdc++.h>
#define endl '\n'
#pragma GCC optimize("O3")
#define ll long long
using namespace std;
const int MAX_N = 80002;
int color[MAX_N],c_cnt[MAX_N];
int c_start,c_inc;
vector< pair<int,int> > tree[MAX_N*4];
int ans = 0,n;
void build(int node, int tl, int tr)
{
    if(tl == tr)
    {
        tree[node].push_back({color[tl],1});
        return;
    }
    int mid = (tl+tr)/2;
    build(node*2, tl, mid);
    build(node*2+1, mid+1, tr);
    int ptr1 = 0;
    int ptr2 = 0;
    for(int i=0; i<(tr-tl+1); i++)
    {
        if(ptr1 == tree[node*2].size())
        {
            if(tree[node*2+1][ptr2].first == tree[node][tree[node].size()-1].first)
            {
                tree[node][tree[node].size()-1].second += tree[node*2+1][ptr2].second;
            }
            else
            {
                tree[node].push_back(tree[node*2+1][ptr2]);
            }
            ptr2++;
        }
        else if(ptr2 == tree[node*2+1].size())
        {
            if(tree[node*2][ptr1].first == tree[node][tree[node].size()-1].first)
            {
                tree[node][tree[node].size()-1].second += tree[node*2][ptr1].second;
            }
            else
            {
                tree[node].push_back(tree[node*2][ptr1]);
            }
            ptr1++;
        }
        else
        {
            if(tree[node*2][ptr1] < tree[node*2+1][ptr2])
            {
                if(tree[node*2][ptr1].first == tree[node][tree[node].size()-1].first)
                {
                    tree[node][tree[node].size()-1].second += tree[node*2][ptr1].second;
                }
                else
                {
                    tree[node].push_back(tree[node*2][ptr1]);
                }
                ptr1++;
            }
            else
            {
                if(tree[node*2+1][ptr2].first == tree[node][tree[node].size()-1].first)
                {
                    tree[node][tree[node].size()-1].second += tree[node*2+1][ptr2].second;
                }
                else
                {
                    tree[node].push_back(tree[node*2+1][ptr2]);
                }
                ptr2++;
            }
        }
    }
}
int query(int node, int tl, int tr, int l, int r, int val)
{
    if(tl > r || tr < l) return 0;
    else if(tl>=l && tr<=r)
    {
        int le = 0;
        int ri = tr-tl+1;
        while(le <= ri)
        {
            int mid = (le+ri)/2;
            if(tree[node][mid].first == val) return tree[node][mid].second;
            else if(tree[node][mid].first < val)
            {
                ri = mid-1;
            }
            else le = mid+1;
        }
        return 0;
    }
    int mid = (tl+tr)/2;
    return query(node*2,tl,mid,l,r,val)+query(node*2+1,mid+1,tr,l,r,val);
}
void solve(int l, int r)
{
//    cout<<l<<" "<<r<<endl;
    if(query(1,1,n,l,r,c_start) == 0) return;
    if(query(1,1,n,l,r,c_inc) == 0)
    {
        ans += ((query(1,1,n,l,r,c_start)*(query(1,1,n,l,r,c_start)-1))/2);
//        cout<<(((pref_start[r]-pref_start[l-1])*(pref_start[r]-pref_start[l-1]-1))/2)<<endl;
        return;
    }
    int middle = (l+r)/2;
    solve(l, middle);
    solve(middle+1, r);
    int ans_left = 0;
    int le = l;
    int ri = middle;
    while(le <= ri)
    {
        int mid = (le+ri)/2;
        if(query(1,1,n,mid,middle,c_inc) == 0)
        {
            ans_left = query(1,1,n,mid,middle,c_start);
            ri = mid-1;
        }
        else le = mid+1;
    }
    int ans_right = 0;
    le = middle+1;
    ri = r;
    while(le <= ri)
    {
        int mid = (le+ri)/2;
        if(query(1,1,n,middle,mid,c_inc) == 0)
        {
            ans_right = query(1,1,n,middle,mid,c_start);
            le = mid+1;
        }
        else ri = mid-1;
    }
    ans+=(ans_left*ans_right);
//    cout<<(ans_left*ans_right)<<endl;
}
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    cin>>n;
    for(int i=1; i<=n; i++)
    {
        cin>>color[i];
        c_cnt[color[i]]++;
    }
    build(1,1,n);
    for(int i=1; i<n; i++)
    {
        int u0,v0;
        cin>>u0>>v0;
    }
    int q;
    cin>>q;
    for(int qt = 1; qt <= q; qt++)
    {
//        cout<<"Q: "<<qt<<endl;
        cin>>c_start>>c_inc;
        if(c_cnt[c_inc] == 0 || c_cnt[c_start] < 2) cout<<0<<endl;
        else if(c_inc == c_start) cout<<((c_cnt[c_start]*(c_cnt[c_start]-1))/2)<<endl;
        else
        {
            ans = 0;
            solve(1,n);
            cout<<(((c_cnt[c_start]*(c_cnt[c_start]-1))/2)-ans)<<endl;
        }
    }
}
/**
7
1 4 1 1 4 5 4
0 0
0 0
0 0
0 0
0 0
0 0
3
1 4
4 1
5 1
*/
