#include<bits/stdc++.h>
#define pb push_back
#define ll long long
#define fr first
#define sc second
#define lsb(x) x & (-x)
#define all(A) A.begin(), A.end()
#define de(x) cout << #x << " = " << x << endl;
using namespace std;

template<class T> using matrix = vector<vector<T>>;

const int MAXN = 8e3 + 3;
const int MAXL = 20;

ll n, k, dp[MAXN][MAXN], inp[MAXN], lg[MAXN], sparse[MAXN][MAXL];

ll cost(ll l, ll r){
    return (r - l + 1) * inp[r];
}

void solve(int lvl, int l, int r, int tl, int tr){
    if(r < l) return;
    int m = (l + r) / 2;
    dp[lvl][m] = LLONG_MAX;
    int be = -1;
    for(int t = tl; t <= min(tr, m); t ++){
        if(dp[lvl - 1][t] + cost(t + 1, m) < dp[lvl][m]){
            dp[lvl][m] = dp[lvl - 1][t] + cost(t + 1, m);
            be = t;
        }
    }
    solve(lvl, l, m - 1, tl, be);
    solve(lvl, m + 1, r, be, tr);
}

int main(){
    cin >> n >> k;
    for(int i = 1; i <= n; i ++){
        cin >> inp[i];
    }
    sort(inp + 1, inp + n + 1);
    for(int i = 1; i <= n; i ++){
        dp[1][i] = cost(1, i);
    }
    for(int _k = 2; _k <= k; _k ++){
        solve(_k, 1, n, 1, n);
    }
    cout << dp[k][n] << endl;
}
/**
10 4
4 1 12 17 7 3 6 8 10 16

94
*/

