#include<bits/stdc++.h>
#define pb push_back
#define ll long long
#define fr first
#define sc second
#define lsb(x) x & (-x)
#define all(A) A.begin(), A.end()
#define de(x) cout << #x << " = " << x << endl;
using namespace std;

template<class T> using matrix = vector<vector<T>>;

const int MAXN = 12003;

ll n, k, dp[2][MAXN], inp[MAXN];

ll cost(ll l, ll r){
    return (r - l + 1) * inp[r];
}

void solve(int l, int r, int tl, int tr){
    if(r < l) return;
    int m = (l + r) / 2;
    dp[1][m] = LLONG_MAX;
    int be = -1;
    for(int t = tl; t <= min(tr, m); t ++){
        if(dp[0][t] + cost(t + 1, m) < dp[1][m]){
            dp[1][m] = dp[0][t] + cost(t + 1, m);
            be = t;
        }
    }
    solve(l, m - 1, tl, be);
    solve(m + 1, r, be, tr);
}

int main(){
    cin >> n >> k;
    for(int i = 1; i <= n; i ++){
        cin >> inp[i];
    }
    sort(inp + 1, inp + n + 1);
    for(int i = 1; i <= n; i ++){
        dp[0][i] = cost(1, i);
    }
    for(int _k = 2; _k <= k; _k ++){
        solve(1, n, 1, n);
        for(int i = 1; i <= n; i ++){
            dp[0][i] = dp[1][i];
        }
    }
    cout << dp[0][n] << endl;
}
/**
10 4
4 1 12 17 7 3 6 8 10 16

94
*/

