#include<bits/stdc++.h>
#define pb push_back
#define ll long long
#define fr first
#define sc second
#define ld long double
#define lsb(x) x & (-x)
#define all(A) A.begin(), A.end()
#define de(x) cout << #x << " = " << x << endl;
using namespace std;

template<class T> using matrix = vector<vector<T>>;

const int MAXN = 1e6 + 6;

struct cht{
    /// decreasing order (by slope)
    /// maximum
    struct line{
        ll slope = 0, y_int = 0;
        /// slope * x + y_int
        line(){}
        line(ll _slope, ll _y_int){
            slope = _slope;
            y_int = _y_int;
        }
        ll get(ll x){
            return x * slope + y_int;
        }
        friend ld intercept(line a, line b){
            return ((ld)a.y_int - (ld)b.y_int) / ((ld)b.slope - (ld)b.y_int);
        }
    };
    vector<line> lines;
    bool check(line p){
        if(p.slope == lines.back().slope)
            return p.y_int >= lines.back().y_int;
        line l1 = lines[lines.size() - 1];
        line l2 = lines[lines.size() - 2];
        return intercept(p, l1) >= intercept(l1, l2);
    }
    void add(ll slope, ll y_int){
        line p = line(slope, y_int);
        while(lines.size() >= 2 && check(p)) lines.pop_back();
        if(lines.empty() || lines.back().slope > p.slope) lines.pb(p);
        else if(!lines.empty() || (lines.back().slope == p.slope && lines.back().y_int < p.y_int)) lines.back() = p;
    }
    ll get(ll x){
        int l = 0, r = lines.size() - 1, bin_ans = 0;
        while(l <= r){
            int m = (l + r) / 2;
            if(m == lines.size() - 1){
                bin_ans = m;
                break;
            }
            else if(lines[m].get(x) < lines[m + 1].get(x)){
                bin_ans = m + 1;
                l = m + 1;
            }
            else{
                r = m - 1;
            }
        }
        cout << lines[bin_ans].slope << " " << lines[bin_ans].y_int << endl;
        return lines[bin_ans].get(x);
    }
};

ll n, k, inp[MAXN], dp[MAXN];

ll oks(ll c){
    vector<ll> dp(n + 1);
    for(ll i = 1; i <= n; i ++){
        dp[i] = LLONG_MAX;
        for(ll j = 0; j < i; j ++){
            dp[i] = min(dp[i], dp[j] - j * inp[i]);
        }
        dp[i] += i * inp[i] + c;
    }
    /// for(auto x : dp) cout << x << " "; cout << endl;
    return dp.back();
}

ll ok(ll c){
    de(c);
    cht cont;
    cont.add(0, 0);
    ll dp = 0;
    for(int i = 1; i <= n; i ++){
        dp = cont.get(inp[i]) + i * inp[i] + c;
        cont.add(-i, dp);
    }
    return dp;
}

int main(){
    cin >> n >> k;
    for(int i = 1; i <= n; i ++){
        cin >> inp[i];
    }
    sort(inp + 1, inp + n + 1);
    /// for(int i = 1; i <= n; i ++) cout << inp[i] << " "; cout << endl;
    ll lc = 0, rc = n - 1, bin_ans = 0;
    while(lc <= rc){
        ll mc = (lc + rc) / 2;
        if(oks(mc)){
            bin_ans = mc;
            lc = mc + 1;
        }
        else{
            rc = mc - 1;
        }
    }
    cout << oks(bin_ans) - k * bin_ans << endl;
}
/**
10 4
4 1 12 17 7 3 6 8 10 16
*/
