#include<bits/stdc++.h>
#define pb push_back
#define ll long long
#define fr first
#define sc second
#define lsb(x) x & (-x)
#define all(A) A.begin(), A.end()
#define de(x) cout << #x << " = " << x << endl;
using namespace std;

template<class T> using matrix = vector<vector<T>>;

const int MAXN = 5e2 + 2;

int n, m, col[MAXN], curr[MAXN];
matrix<int> G;

int dfs(int u, int p, int x, int y){
    int ret = 0;
    curr[col[u]] ++;
    if(col[u] == x && curr[y]){
        ++ ret;
    }
    for(auto v : G[u]){
        if(v != p){
            ret += dfs(v, u, x, y);
        }
    }
    curr[col[u]] --;
    return ret;
}

int main(){
    cin >> n;
    G = matrix<int>(n + 1);
    for(int i = 1; i <= n; i ++) cin >> col[i];
    for(int i = 0; i < n - 1; i ++){
        int u, v; cin >> u >> v;
        G[u].pb(v);
        G[v].pb(u);
    }
    int q; cin >> q;
    for(int i = 0; i < q; i ++){
        int x, y, ans = 0; cin >> x >> y;
        for(int u = 1; u <= n; u ++){
            if(col[u] == x){
                ans += dfs(u, -1, x, y);
            }
        }
        cout << ans / 2 << endl;
    }
}
/**
7
1 3 2 2 1 1 1
1 2
1 3
2 4
2 5
3 6
4 7
6
1 2
2 1
1 3
3 1
2 3
3 2

5
1
5
0
1
0
*/
