#include<iostream>
#include<vector>
#include<unordered_set>
#define MAXN 80001
using namespace std;
vector<int> G[MAXN];
vector<unordered_set<int>> paths[MAXN];
int C[MAXN];
int N;
int Q;
int u,v;
bool used[MAXN];
void init()
{
    cin>>N;
    used[0]=true;
    for(int i=1;i<=N;i++)
    {
        used[i]=false;
        cin>>C[i];
    }
    for(int i=1;i<N;i++)
    {
        cin>>u>>v;
        G[v].push_back(u);
        G[u].push_back(v);
    }
}
int path[MAXN];

int s;

void dfs(int v,int l=0)
{
    static int u;
    used[v]=true;
    path[l]=C[v];
    if(C[s]==C[v]&&l>=1)
        paths[s].push_back(unordered_set<int>(path,path+l+1));
    for(int i=0;i<G[v].size();i++)
        if(!used[G[v][i]])
            dfs(G[v][i],l+1);
    used[v]=false;
}
void printG()
{
    for(int v=1;v<=N;v++)
    {
        for(int i=0;i<G[v].size();i++)
            cout<<G[v][i]<<' ';
        cout<<endl;
    }
}
void showSet()
{
    for(int i=1;i<=N;i++)
    {
        cout<<": "<<i<<endl;
        for(int j=0;j<paths[i].size();j++)
        {
            for(int a:paths[i][j])
                cout<<a<<' ';
            cout<<endl;
        }
        cout<<endl;
    }
}
int main()
{
    init();
    printG();
    for(s=1;s<=N;s++)
        dfs(s);
    cin>>Q;
    int b;
    for(int i=0;i<Q;i++)
    {
        b=0;
        cin>>u>>v;
        for(int j=1;j<=N;j++)
            if(C[j]==u)
            {
                for(unordered_set<int> a:paths[j])
                    if(a.find(v)!=a.end())b++;
            }
        cout<<b/2<<endl;
    }
    return 0;
}
/*
7
1 3 2 2 1 1 1
1 2
1 3
2 4
2 5
3 6
4 7
6
1 2
2 1
1 3
3 1
2 3
3 2
*/
