#include<iostream>
#include<vector>
#include<unordered_set>
#include<unordered_map>
#include<cstdio>
#define MAXN 80001
using namespace std;
vector<int> G[MAXN];
unordered_map<int,vector<unordered_set<int>>> paths;
int C[MAXN];
int N;
int Q;
int u,v;
bool used[MAXN];
void init()
{
    scanf("%d",&N);
    used[0]=true;
    for(int i=1;i<=N;i++)
    {
        used[i]=false;
        scanf("%d",&C[i]);
    }
    for(int i=1;i<N;i++)
    {
        scanf("%d %d",&u,&v);
        G[v].push_back(u);
        G[u].push_back(v);
    }
}

int s;
int k;

int dfs(int v,int l=0,bool contains=false)
{
    int res=0;
    used[v]=true;
    if(C[v]==k)contains=true;
    //printf("%d | %d: %d %d (%d)\n",C[s],v,C[v],k,contains);
    if(C[s]==C[v]&&contains)
        res=1;
    for(int i=0;i<G[v].size();i++)
        if(!used[G[v][i]])
            res+=dfs(G[v][i],l+1,contains);
    used[v]=false;
    //cout<<res<<endl;
    return res;
}
void printG()
{
    for(int v=1;v<=N;v++)
    {
        for(int i=0;i<G[v].size();i++)
            cout<<G[v][i]<<' ';
        cout<<endl;
    }
}
void showSet()
{
    for(auto b:paths)
    {
        cout<<": "<<b.first<<endl;
        for(int j=0;j<b.second.size();j++)
        {
            for(int a:b.second[j])
                cout<<a<<' ';
            cout<<endl;
        }
        cout<<endl;
    }
}
int main()
{
    init();
    //printG();
    //for(s=1;s<=N;s++)
        //if(paths.find(C[s])==paths.end())
            //dfs(s);
    //showSet();
    scanf("%d",&Q);
    int b;
    for(int i=0;i<Q;i++)
    {
        b=0;
        scanf("%d %d",&u,&k);
        for(s=1;s<=N;s++)
            if(C[s]==u)
                b+=dfs(s);
        cout<<(b>>1)<<endl;
    }
    return 0;
}
/*
7
1 3 2 2 1 1 1
1 2
1 3
2 4
2 5
3 6
4 7
6
1 2
2 1
1 3
3 1
2 3
3 2
*/
/*
7
1 2 3 3 1 3 1
1 2
2 3
3 4
4 5
5 6
6 7
6
1 2
1 3
2 3
2 1
3 1
3 2
*/
