template <uint N>
struct ZeroArray
{
    uint vals[N];

    constexpr ZeroArray(): vals()
    {
        for (uint j = 0; j < N; ++j)
        {
            vals[j] = 0;
        }
    }
};

struct InitializedArray
{
    uint vals[1000];

    constexpr InitializedArray(): vals()
    {
        for (uint j = 0; j < 1000; ++j)
        {
            vals[j] = j * 3;
        }
    }
};

constexpr InitializedArray globArr;

constexpr uint stateSize(uint n)
{
    return 1;
}

constexpr void processOne(uint n, uint i, uint curr, State& state){
    if(state[0]%1000==0 and curr!=0){
        state[0] = state[0] + 1000;
        state[0] = state[0] + curr;
    }else{
        if(state[0]%1000 == curr){
            state[0]=state[0]+1000;
        }
    }
}

constexpr uint getAnswer(uint n, const State& state)
{
    int ans = (state[0]/1000)%1000;
    int num = 1000/ans;
    int ans1=0;
    for(int i=0;i<num;i++){
        ans1=ans1+ans*ans;
    }
    return ans1;
}

