#include<bits/stdc++.h>
using namespace std;
#define ld long double
#define ll long long
const ld eps=1e-40;
const int MAXN=12002;
int n,k;
ll dp[MAXN][2];
ld r[MAXN];
ll slow()
{
    for(int i=0;i<16;i++)
    {
        for(int j=0;j<16;j++)
        {
            dp[i][j]=999999999999999999;
        }
    }
    dp[0][0]=0;
    for(ll i=1;i<=n;i++)
    {
        for(ll j=1;j<=k;j++)
        {
            ll mx=0;
            for(ll i1=i;i1>=1;i1--)
            {
                mx=max(mx,(ll)r[i1]);
                dp[i][j]=min(dp[i][j],(ll)dp[i1-1][j-1]+mx*(i-i1+1));
            }
        }
    }
    return dp[n][k];
}
struct line
{
    ld a,b;
    int cnt;
    ld eval(ld x)
    {
        return a*x+b;
    }
};
ld intersect(line l1,line l2)
{
    //l1.a*x+l1.b=l2.a*x+l2.b
    //x=(l2.b-l1.b)/(l1.a-l2.a);
    return (l2.b-l1.b)/(l1.a-l2.a);
}
struct cht
{
    deque<line>lines;
    void add(line l)
    {
        while(lines.size()>1&&intersect(lines[lines.size()-2],l)<intersect(lines[lines.size()-2],lines[lines.size()-1]))
        {
            lines.pop_back();
        }
        lines.push_back(l);
    }
    pair<ld,int> ask(ld x)
    {
        while(lines.size()>1&&(lines[0].eval(x)>lines[1].eval(x) || (lines[0].eval(x)==lines[1].eval(x) && lines[0].cnt < lines[1].cnt)))
        {
            //cout<<"% "<<x<<" "<<lines[0].eval(x)<<endl;
            lines.pop_front();
        }
        return {lines[0].eval(x),lines[0].cnt+1};
    }
}ez;
pair<ld,int> solve(ld pen)
{
    ez.lines.clear();
    for(int i=1;i<=n;++i)
    {
        pair<ld,int> dp=make_pair(pen+1.0*i*r[i],1);
        if(i!=1)
        {
            pair<ld,int> dp1=ez.ask(r[i]);
            dp1.first+=pen;
            dp1.first+=(ld)1.0*i*r[i];
            if(dp.first!=dp1.first)dp=min(dp,dp1);
            else dp=max(dp,dp1);
        }
        /*cout<<i<<" : "<<dp.first<<","<<dp.second<<endl;
        for(auto xd:ez.lines)cout<<"("<<xd.a<<","<<xd.b<<","<<xd.cnt<<") ";
        cout<<endl;*/
        if(i==n)
        {
            return dp;
        }
        ez.add({-i,dp.first,dp.second});
    }
}
ll fast()
{
    ld low=-eps,high=1e18,mid,best=-high,ans=high,maxbigger=-1,minsmaller=high;
    for(int i=0;i<20&&low<high-eps;++i)
    {
        mid=(ld)(low+high)/2.0;
        //cout<<i<<" "<<fixed<<setprecision(12)<<mid<<" "<<solve(mid).first<<" "<<solve(mid).second<<endl;
        pair<ld,int> p=solve(mid);
        int f=p.second;
        if(f>k)maxbigger=max(maxbigger,mid);
        if(f<k)minsmaller=min(minsmaller,mid);
        if(f==k)
        {
            best=max(best,mid);
            ans=min(ans,p.first-(ld)1.0*k*mid);
        }
        if(f<k)
        {
            high=mid;
        }
        else low=mid;
    }
    if(best<0)
    {
        /*pair<ld,int>p1=solve(maxbigger);
        pair<ld,int>p2=solve(minsmaller);
        ld d1=abs(p1.second-k),d2=abs(p2.second-k);
        ld c1=d2/(d1+d2);
        ld c2=d1/(d1+d2);
        ans=(p1.first*c1+p2.first*c2)-(ld)1.0*k*(maxbigger*c1+minsmaller*c2);*/
        ans=solve(high).first-(ld)1.0*k*high;
        //ans++;
    }
    //cout<<fixed<<setprecision(10)<<ans<<endl;
    return (ll)max((ld)round(ans),(ld)0);
}
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    cin>>n>>k;
    for(int i=1;i<=n;++i)
    {
        cin>>r[i];
    }
    sort(r+1,r+n+1);
    //cout<<slow()<<" "<<fast()<<endl;


    //solve(24);
    if(n>=MAXN-1)
    {
        cout<<fast()<<'\n';
        return 0;
    }
    cht bruh;
    for(int j=1;j<=k;++j)
    {
        bruh.lines.clear();

        for(int i=1;i<=n;++i)
        {
            dp[i][j%2]=r[i]*i;
            if(bruh.lines.size()>0)
            {
                pair<ld,int> dp1=bruh.ask(r[i]);
                dp1.first+=i*r[i];
                dp[i][j%2]=min(dp[i][j%2],(ll)dp1.first);
            }
            if(j!=1)bruh.add({-i,dp[i][1-j%2],j-1});
            //cout<<i<<" "<<j<<" "<<dp[i][j%2]<<endl;
        }
    }
    cout<<dp[n][k%2]<<'\n';
    /*for(;;)
    {
        n=10;k=rand()%n+1;
        for(int i=1;i<=n;i++)
        {
            r[i]=rand()%100000;
        }
        sort(r+1,r+n+1);
        if(slow()!=fast())
        {
            cout<<n<<" "<<k<<endl;
            cout<<slow()<<" "<<fast()<<endl;
            for(int i=1;i<=n;i++)
            {
                cout<<r[i]<<" ";
            }
            cout<<endl;
            break;
        }
    }*/
return 0;
}
/*
10 4
4 1 12 17 7 3 6 8 10 16
*/
/*
10 2
1 2 3 4 5 6 7 8 9 10
*/
/*
5 4
0 1000000000000 0 1000000000000 1000000000000
*/
/*
6 2
23493427732 32423423 12121 40923048329 1332432444 32235999
*/
/*
10 2
0 2 4 4 4 5 7 8 8 9
*/
/*
10 4
0 1 2 5 6 6 8 8 9 9
*/
