#include <algorithm>
#include <iostream>
#define endl '\n'
using namespace std;

const int BUFFER_LENGTH = 100000;

char buffer[BUFFER_LENGTH];
int buffer_pos = 0;

void read_char()
{
    if (++ buffer_pos == BUFFER_LENGTH) fread(buffer, 1, BUFFER_LENGTH, stdin), buffer_pos = 0;
}

int int_value;

int read_int()
{
    int_value = 0;
    for (; buffer[buffer_pos] < '0' or buffer[buffer_pos] > '9'; read_char());
    for (; buffer[buffer_pos] >= '0' and buffer[buffer_pos] <= '9'; read_char())
    {
        int_value = int_value * 10 + (buffer[buffer_pos] - '0');
    }
    return int_value;
}

const int MAXN = 1000;

int r[MAXN + 5];
long long dp[MAXN + 5][MAXN + 5];

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    int n, k;
    n = read_int();
    k = read_int();

    for (int i = 1; i <= n; ++ i)
    {
        r[i] = read_int();
    }

    sort(r + 1, r + n + 1);

    for (int i = 1; i <= n; ++ i)
    {
        for (int t = 0; t <= k; ++ t)
        {
            dp[i][t] = (long long)(1e18);
        }
    }

    dp[0][0] = 0;
    for (int i = 1; i <= n; ++ i)
    {
        for (int j = 0; j < i; ++ j)
        {
            for (int t = 1; t <= min(i, k); ++ t)
            {
                dp[i][t] = min(dp[i][t], dp[j][t - 1] + 1ll * (i - j) * r[i]);
            }
        }
    }

    cout << dp[n][k] << endl;

    return 0;
}
