// Sample program that does nothing sensible but demonstrates how to use constexpr

constexpr uint stateSize(uint n){
    return 4;
}

constexpr void processOne(uint n, uint i, uint curr, State& state){
    if(state[0]==0){
        state[0]=curr;
    }
    if(state[2]==0 and curr!=state[0]){
        state[2]=curr;
    }
    if(state[4]==0 and curr!=state[0] and curr!=state[2]){
        state[4]=curr;
    }
    if(state[6]==0 and curr!=state[0] and curr!=state[2] and curr!=state[4]){
        state[6]=curr;
    }
    if(curr==state[0])state[1]++;
    if(curr==state[2])state[3]++;
    if(curr==state[4])state[5]++;
    if(curr==state[6])state[7]++;
}

constexpr uint getAnswer(uint n, const State& state){
    int st=0;
    if(state[6]!=0){
        st=(state[1]+state[3]+state[5]+state[7])/4;
    }else if(state[4]!=0){
        st=(state[1]+state[3]+state[5])/3;
    }else if(state[2]!=0){
        st=(state[1]+state[3])/2;
    }else{
        st=(state[1]);
    }
    return (n/st)*st*st;
}
