#include <bits/stdc++.h>
using namespace std;

const int maxn = 1003;
int n, k;
long long a [maxn];
long long dp [maxn][maxn];
int bestprev [maxn];

int main (){

    ios::sync_with_stdio (false);
    cin.tie (0);

    cin >> n >> k;
    for (int i = 0; i < n; i ++){
        cin >> a [i];
    }
    sort (a, a + n);

    for (int i = 0; i < n; i ++) dp [i][0] = (i + 1) * a [i];
    for (int i = 1; i < k; i ++){
        bestprev [1] = 0;
        for (int j = 2; j < n; j ++){
            long long x = bestprev [j - 1];
            while (x < j - 1 && dp [x][i - 1] - (x + 1) * a [j] >= dp [x + 1][i - 1] - (x + 2) * a [j]) x ++;
            bestprev [j] = x;
        }
        dp [0][i] = a [0];
        for (int j = 1; j < n; j ++) dp [j][i] = (j + 1) * a [j] + dp [bestprev [j]][i - 1] - (bestprev [j] + 1) * a [j];
    }
    cout << dp [n - 1][k - 1];

}
/*
10000000000
10 4
100000000004 100000000001 100000000012 100000000017 100000000007 100000000003 100000000006 100000000008 100000000010 100000000016
*/
