#include <bits/stdc++.h>
using namespace std;

const int maxn = 10004;
int n, q;
int c [maxn];
vector <int> adj [maxn];
short cnt [maxn][maxn];

void dfs (int a, int par){
    cnt [a][c [a]] = 1;
    for (int i : adj [a]){
        if (i == par) continue;
        dfs (i, a);
        for (int j = 1; j <= n; j ++) cnt [a][j] += cnt [i][j];
    }
}

int x, y, ans;
int dfs2 (int a, int par, int cntx){
    int coveredx = 0;
    if (c [a] == y){
        int totalx = cntx;
        for (int i : adj [a]){
            if (i == par) continue;
            ans += totalx * cnt [i][x];
            totalx += cnt [i][x];
        }
        cntx = 0;
        coveredx = cnt [a][x];
    }
    for (int i : adj [a]){
        if (i == par) continue;
        if (c [a] == y) dfs2 (i, a, 0);
        else coveredx += dfs2 (i, a, cntx + cnt [a][x] - cnt [i][x] - coveredx);
    }
    return coveredx;
}

int main (){

    ios::sync_with_stdio (false);
    cin.tie (0);

    cin >> n;
    for (int i = 1; i <= n; i ++) cin >> c [i];
    for (int i = 1; i < n; i ++){
        int u, v;
        cin >> u >> v;
        adj [u].push_back (v);
        adj [v].push_back (u);
    }
    dfs (1, 0);

    cin >> q;
    for (int i = 0; i < q; i ++){
        cin >> x >> y;
        ans = 0;
        dfs2 (1, 0, 0);
        cout << ans << '\n';
    }

}
