// Sample program that does nothing sensible but demonstrates how to use constexpr

template <uint N>
struct ZeroArray
{
    uint vals[N];

    constexpr ZeroArray(): vals()
    {
        for (uint j = 0; j < N; ++j)
        {
            vals[j] = 0;
        }
    }
};

constexpr uint stateSize(uint n)
{
    return 1;
}

constexpr void processOne(uint n, uint i, uint curr, State& state)
{
    if(curr == 1) {
        state[0] ++;
    }
}

constexpr uint getAnswer(uint n, const State& state)
{
    return state[0] * n;
}
