#include <bits/stdc++.h>
using namespace std;
#ifdef EVAL
#define cerr if(false)cerr
#endif // EVAL
#define endl "\n"
typedef long long ll;
const ll mod = 1e16 + 7;
template<class T, class T2> bool chkmin(T &a, const T2 &b) { return (a > b) ? a = b, 1: 0;}
template<class T, class T2> bool chkmax(T &a, const T2 &b) { return (a < b) ? a = b, 1: 0;}

const int MAX_N = 1.2e4 + 10;
ll dp[MAX_N][MAX_N];
ll n, k;
ll arr[MAX_N];

struct Line {
    ll m, b;
    long double p;

    Line(ll m, ll b) : m(m), b(b) {
        p = 1e18;
    }
};

long double intersect(const Line &a, const Line &b) {
    return (a.b - b.b) / (b.m - a.m);
}

struct LineContainer {
    deque<Line> cont;

    void push_back(Line nw) {
        while(cont.size() >= 2 && intersect(cont[cont.size() - 2], nw) < cont[cont.size() - 1].p) {
            cont.pop_back();
        }
        if(!cont.empty()) {
            cont[cont.size() - 1].p = intersect(cont[cont.size() - 1], nw);
        }
        cont.push_back(nw);
    }

    ll ans(ll x) {
        while(!cont.empty() && x > cont.front().p) {
            cont.pop_front();
        }
        if(cont.empty()) {
            return 1e18;
        }
        return cont.front().m * x + cont.front().b;
    }
};

LineContainer lc[MAX_N];

signed main() {
#ifdef EVAL
    ios_base::sync_with_stdio(false); cin.tie(NULL);
#endif // EVAL

    cin >> n >> k;
    for(int i = 1; i <= n; i ++) {
        cin >> arr[i];
    }
    sort(arr + 1, arr + n + 1);

    for(int i = 0; i < MAX_N; i ++) {
        for(int j = 0; j < MAX_N; j ++) {
            dp[i][j] = mod;
        }
    }
    lc[0].push_back(Line(0, 0));

    for(int i = 1; i <= n; i ++) {
        for(int j = k; j >= 1; j --) {
            dp[i][j] = min(mod, lc[j - 1].ans(arr[i]) + i * arr[i]);
            if(dp[i][j] < 1e16) {
                lc[j].push_back(Line(-i, dp[i][j]));
            }
        }
    }

    cout << dp[n][k] << endl;

    return 0;
}

