#include <bits/stdc++.h>
using namespace std;
#ifdef EVAL
#define cerr if(false)cerr
#endif // EVAL
#define endl "\n"
typedef long long ll;
const ll mod = 1e9 + 7;
template<class T, class T2> bool chkmin(T &a, const T2 &b) { return (a > b) ? a = b, 1: 0;}
template<class T, class T2> bool chkmax(T &a, const T2 &b) { return (a < b) ? a = b, 1: 0;}

const ll MAX_N = 1e5 + 10, LOG = 17;
ll n, q;
vector<ll> g[MAX_N];
ll col[MAX_N];
vector<ll> who[MAX_N];
vector<pair<ll, ll> > quer[MAX_N], toApply[MAX_N];

ll cnt[MAX_N], total[MAX_N], sum[MAX_N];
vector<ll> cntVec, totalVec, sumVec;

ll ans[MAX_N];
bool used[MAX_N];

void dfs(ll x, ll p, ll c) {
    if(used[x] || col[x] == c) {
        cerr << "Ret " << x << endl;
        return;
    }
    cnt[col[x]] ++;
    sum[col[x]] += total[col[x]];
    used[x] = true;
    cerr << "Got for " << x << " " << col[x] << " " << cnt[col[x]] << " " << total[col[x]] << " " << sum[col[x]] << endl;
    cntVec.push_back(col[x]);
    sumVec.push_back(col[x]);
    for(auto it : g[x]) {
        if(it == p) {continue;}
        dfs(it, x, c);
    }
}

void solve_big(ll c) {
    for(ll i = 1; i <= n; i ++) {
        used[i] = false;
    }

    cerr << "Solving for color " << c << endl;

    for(ll i = 1; i <= n; i ++) {
        if(!used[i]) {
            dfs(i, -1, c);
            for(const auto &it : cntVec) {
                total[it] += cnt[it];
                cnt[it] = 0;
                totalVec.push_back(it);
            }

            cerr << "DEBUGGING" << endl;
            for(ll it = 1; it <= n; it ++) {
                cerr << cnt[it] << " " << total[it] << " " << sum[it] << endl;
            }
            cerr << "ENDING" << endl;
            cntVec.resize(0);
        }
    }

    for(auto it : quer[c]) {
        ans[it.second] = sum[it.first];
    }

    for(const auto &it : totalVec) {
        total[it] = 0;
    }
    totalVec.resize(0);
    for(const auto &it : sumVec) {
        sum[it] = 0;
    }
    sumVec.resize(0);
    cerr << "DEBUGGING" << endl;
    for(ll it = 1; it <= n; it ++) {
        cerr << cnt[it] << " " << total[it] << " " << sum[it] << endl;
    }
    cerr << "ENDING" << endl;
}

ll in[MAX_N], out[MAX_N], tme = -1;
ll d[MAX_N];

ll par[MAX_N];
vector<ll> allPars[MAX_N];
bool isPar[MAX_N];

void solve_small(ll c) {
    for(const auto &it : quer[c]) {
        toApply[it.first].push_back({c, it.second});
    }
    sort(who[c].begin(), who[c].end());
}

struct SegTree {
    ll tree[4 * MAX_N];

    void upd(ll curr, ll l, ll r, ll ind, ll val) {
        if(l == r && l == ind) {
            tree[curr] += val;
            return;
        } else if(l > ind || r < ind) {
            return;
        }
        ll m = (l + r) / 2ll;
        upd(curr * 2, l, m, ind, val);
        upd(curr * 2 + 1, m + 1, r, ind, val);
        tree[curr] = tree[curr * 2] + tree[curr * 2 + 1];
    }

    ll sum(ll curr, ll l, ll r, ll ql, ll qr) {
        if(ql <= l && r <= qr) {
            return tree[curr];
        } else if(l > qr || r < ql) {
            return 0;
        }
        ll m = (l + r) / 2ll;
        return sum(curr * 2, l, m, ql, qr) + sum(curr * 2 + 1, m + 1, r, ql, qr);
    }
};

SegTree st, bad;

ll dp[MAX_N];

vector<ll> aux[MAX_N];
ll sz[MAX_N], what[MAX_N];

void apply_small(ll c) {
    if(toApply[c].size() == 0) {return;}
    for(const auto it : who[c]) { st.upd(1, 0, MAX_N - 1, in[it], 1); }

    for(const auto &it : toApply[c]) {
        ll total = who[c].size();

        if(who[it.first].empty()) {
            continue;
        }

        for(ll i = 0; i < who[it.first].size() - 1; i ++) {
            ll now = st.sum(1, 0, MAX_N - 1, who[it.first][i], who[it.first][i + 1]);
            ans[it.second] += now * (total - now);
        }
        ll now1 = st.sum(1, 0, MAX_N - 1, 0, who[it.first][0]);
        ans[it.second] += now1 * (total - now1);
        ll now2 = st.sum(1, 0, MAX_N - 1, who[it.first].back(), MAX_N - 1);
        ans[it.second] += now2 * (total - now2);
    }

    for(const auto it : who[c]) { st.upd(1, 0, MAX_N - 1, in[it], -1); }
    return;
}

signed main() {
#ifdef EVAL
    ios_base::sync_with_stdio(false); cin.tie(NULL);
#endif // EVAL

    cin >> n;
    for(ll i = 1; i <= n; i ++) {
        cin >> col[i];
        who[col[i]].push_back(i);
    }
    g[0].push_back(1);
    for(ll i = 0; i < n - 1; i ++) {
        ll a, b;
        cin >> a >> b;
        g[a].push_back(b);
        g[b].push_back(a);
    }

    cin >> q;
    for(ll i = 0; i < q; i ++) {
        ll x, y;
        cin >> x >> y;
        quer[y].push_back({x, i});
    }

    const ll BLOCK = 100;

    for(ll i = 1; i <= n; i ++) {
        if(who[i].size() <= BLOCK) {
            solve_small(i);
        } else {
            solve_big(i);
        }
    }

    for(ll i = 1; i <= n; i ++) {
        apply_small(i);
    }

    for(ll i = 0; i < q; i ++) {
        cout << ans[i] << endl;
    }

    return 0;
}

