#include <algorithm>
#include <iostream>

typedef long long llong;
const int MAXN = 1000000 + 10;
const llong INF = 1e18;

llong a[MAXN], n, k;
llong dp[2][MAXN];
llong opt[MAXN];

void solve()
{
    std::sort(a+1, a+1+n);
    std::fill(dp[0]+1, dp[0]+n+1, INF);
    for (int currK = 1 ; currK <= k ; ++currK)
    {
        for (int i = 1 ; i <= n ; ++i)
        {
            dp[currK&1][i] = INF;
            llong max = a[i];
            for (int j = i+1 ; j <= n+1 ; ++j)
            {
                if (dp[currK&1][i] > dp[!(currK&1)][j] + max * (j-i))
                {
                    dp[currK&1][i] = dp[!(currK&1)][j] + max * (j-i);
                    opt[i] = j;
                }
                max = std::max(max, a[j]);
            }
        }
    }

    std::cout << dp[k&1][1] << '\n';
}

void read()
{
    std::cin >> n >> k;
    for (int i = 1 ; i <= n ; ++i)
    {
        std::cin >> a[i];
    }
}

void fastIO()
{
    std::ios_base :: sync_with_stdio(0);
    std::cout.tie(nullptr);
}

int main()
{
    fastIO();
    read();
    solve();

    return 0;
}