#include<bits/stdc++.h>
#define endl '\n'

using namespace std;
typedef long long ll;

void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
}
const int maxn = 80010, maxc = 101;

int n, q, c[maxn], cnt[maxn];
vector < int > g[maxn], col[maxn];
int in[maxn], out[maxn], f[maxn * 2], timer, lvl[maxn], closest[maxn];
void euler(int v, int p)
{
    f[++ timer] = v;
    in[v] = timer;
    for (int u : g[v])
    {
        if (u == p)
            continue;
            lvl[u] = lvl[v] + 1;
        euler(u, v);
        f[++ timer] = v;
    }
    out[v] = timer;
}

const int maxlog = 20;
int dp[maxlog][2 * maxn], lg[2 * maxn];
void build_sparse_table()
{
    for (int i = 1; i <= timer; i ++)
        lg[i] = lg[i / 2] + 1, dp[0][i] = f[i];

    for (int j = 1; j < lg[timer]; j ++)
        for (int i = 1; i <= timer - (1 << (j)) + 1; i ++)
    {
        dp[j][i] = dp[j - 1][i];
        if (lvl[dp[j - 1][i + (1 << (j - 1))]] < lvl[dp[j][i]])
        {
            dp[j][i] = dp[j - 1][i + (1 << (j - 1))];
        }
    }
}

int find_lca(int v, int u)
{
    int l = in[v], r = in[u];
    if (l > r)
        swap(l, r);
    int len = lg[r - l + 1] - 1, ans = dp[len][l];
    if (lvl[dp[len][r - (1 << len) + 1]] < lvl[ans])
        ans = dp[len][r - (1 << len) + 1];
    return ans;
}


int ask[10010][10010], sm[maxn], nt, ridx[maxn];
vector < int > to_calc[maxn];
vector < int > sp;
void dfs(int v, int p, int cur, int cur_col)
{
    to_calc[cur].push_back(v);
    for (int u : g[v])
    {
        if (u == p)
            continue;
        if (c[v] == cur_col)
            dfs(u, v, nt ++, cur_col);
        else
        dfs(u, v, cur, cur_col);

    }
}

const int block = 100;
void solve()
{
    cin >> n;
    for (int i = 1; i <= n; i ++)
        cin >> c[i], col[c[i]].push_back(i);
    for (int i = 1; i < n; i ++)
    {
        int a, b;
        cin >> a >> b;
        g[a].push_back(b);
        g[b].push_back(a);
    }

    int so_far = 0;
    for (int i = 1; i <= n; i ++)
    {
        //if (col[i].size() > block)
        //{
            for (int v : col[i])
            sp.push_back(v);
            ridx[i] = ++ so_far;
        //}
    }

    for (int i = 1; i <= n; i ++)
    {
        nt = 2;
        dfs(1, -1, 1, i);
        for (int j = 1; j <= n; j ++)
        {
            for (int v : to_calc[j])
                sm[ridx[c[v]]] ++;
            for (int v : to_calc[j])
            {
                ask[ridx[c[v]]][ridx[i]] += (sm[ridx[c[v]]] * (sm[ridx[c[v]]] - 1) / 2);
                sm[ridx[c[v]]] = 0;
            }
            to_calc[j].clear();
        }
    }

    euler(1, -1);
    build_sparse_table();
    cin >> q;
    for (int i = 1; i <= q; i ++)
    {
        int x, y;
        cin >> x >> y;

        if (col[x].size() <= block && col[y].size() <= block)
        {
        for (int ver : col[x])
        {
            int dw = -1;
            for (int u : col[y])
            {
                if (in[u] <= in[ver] && out[u] >= out[ver] && lvl[u] > dw)
                    dw = lvl[u];
            }
            closest[ver] = dw;
        }

        int cur_ans = 0;

        for (int id1 = 0; id1 < col[x].size(); id1 ++)
            for (int id2 = id1; id2 < col[x].size(); id2 ++)
        {
            int v1 = col[x][id1], v2 = col[x][id2];
            int lca = find_lca(v1, v2);
            if (lvl[lca] <= closest[v1] || lvl[lca] <= closest[v2])
            {
                cur_ans ++;
            }
        }

        cout << cur_ans << endl;
        }
        else
        {

              cout << col[x].size() * (col[x].size() - 1) / 2 - ask[ridx[x]][ridx[y]] << endl;
        }

    }

}

int main()
{
    speed();
    solve();
    return 0;
}
