#include<bits/stdc++.h>
#define endl '\n'

using namespace std;
typedef long long ll;

void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
}
const int maxn = 80010, maxc = 101;

int n, q, c[maxn], cnt[maxn];
vector < int > g[maxn], col[maxn];
int in[maxn], out[maxn], f[maxn * 2], timer, lvl[maxn], closest[maxn];
void euler(int v, int p)
{
    f[++ timer] = v;
    in[v] = timer;
    for (int u : g[v])
    {
        if (u == p)
            continue;
        lvl[u] = lvl[v] + 1;
        euler(u, v);
        f[++ timer] = v;
    }
    out[v] = timer;
}

const int maxlog = 20;
int dp[maxlog][2 * maxn], lg[2 * maxn];
void build_sparse_table()
{
    for (int i = 1; i <= timer; i ++)
        lg[i] = lg[i / 2] + 1, dp[0][i] = f[i];

    for (int j = 1; j < lg[timer]; j ++)
        for (int i = 1; i <= timer - (1 << (j)) + 1; i ++)
        {
            dp[j][i] = dp[j - 1][i];
            if (lvl[dp[j - 1][i + (1 << (j - 1))]] < lvl[dp[j][i]])
            {
                dp[j][i] = dp[j - 1][i + (1 << (j - 1))];
            }
        }
}

int find_lca(int v, int u)
{
    int l = in[v], r = in[u];
    if (l > r)
        swap(l, r);
    int len = lg[r - l + 1] - 1, ans = dp[len][l];
    if (lvl[dp[len][r - (1 << len) + 1]] < lvl[ans])
        ans = dp[len][r - (1 << len) + 1];
    return ans;
}


int ask[10010][10010], sm[2 * maxn], nt, ridx[maxn];
vector < int > to_calc[maxn];
vector < int > sp;
void dfs(int v, int p, int cur, int cur_col)
{
    to_calc[cur].push_back(v);
    for (int u : g[v])
    {
        if (u == p)
            continue;
        if (c[v] == cur_col)
            dfs(u, v, nt ++, cur_col);
        else
            dfs(u, v, cur, cur_col);

    }
}

const int block = 100;

vector < pair < int, int > > cp[maxn];

struct merge_sort_tree
{
    vector < pair < int, int > > seg;
    vector < vector < pair < int, int > > > tree;
    vector < vector < int > > par;

    void conquer(int root, int root1, int root2)
    {
        int id1 = 0, id2 = 0;
        while(id1 < tree[root1].size() && id2 < tree[root2].size())
        {
            if (tree[root1][id1].first < tree[root2][id2].first)
            {
                tree[root].push_back(tree[root1][id1 ++]);
            }
            else
            {
                tree[root].push_back(tree[root2][id2 ++]);
            }
        }

        while(id1 < tree[root1].size())
            tree[root].push_back(tree[root1][id1 ++]);
        while(id2 < tree[root2].size())
            tree[root].push_back(tree[root2][id2 ++]);

        par[root].resize(tree[root].size());

        par[root].back() = tree[root].back().second;
        for (int i = (int)(tree[root].size()) - 2; i >= 0; i --)
        {
            par[root][i] = max(par[root][i + 1], tree[root][i].second);
        }
    }
    void divide(int root, int l, int r)
    {
        if (l == r)
        {
            tree[root].push_back({seg[l].second, lvl[f[seg[l].first]]});
                    par[root].resize(tree[root].size());

        par[root].back() = tree[root].back().second;
            return;
        }

        int mid = (l + r) / 2;
        divide(root * 2, l, mid);
        divide(root * 2 + 1, mid + 1, r);

        conquer(root, root * 2, root * 2 + 1);
    }

    int query_node(int root, int val)
    {
        int l = 0, r = (int)(tree[root].size()) - 1;
        while(l <= r)
        {
            int m = (l + r) / 2;
            if (tree[root][m].first >= val)
                r = m - 1;
            else
                l = m + 1;
        }

       /**for (pair < int, int > cur : tree[root])
        cout << cur.first << " :: " << cur.second << endl;
        cout << l << endl;*/
        if (l == tree[root].size())
            return -1;
        return par[root][l];
    }
    int query(int root, int left, int right, int qleft, int qright, int bor)
    {
        ///cout << root << " " << left << " " << right << " " << qleft << " " << qright << " " << bor << endl;
        if (left > qright || right < qleft)
            return -1;

        if (left >= qleft && right <= qright)
        {
            return query_node(root, bor);
        }

        int mid = (left + right) / 2;
        return max(query(root * 2, left, mid, qleft, qright, bor),
                query(root * 2 + 1, mid + 1, right, qleft, qright, bor));
    }
    void build_mst(vector < pair < int, int > > _seg)
    {
        seg = _seg;
        tree.resize(4 * seg.size());
        par.resize(4 * seg.size());
        divide(1, 0, seg.size() - 1);
    }
};

merge_sort_tree mst[maxn];
void solve()
{
    cin >> n;
    for (int i = 1; i <= n; i ++)
        cin >> c[i], col[c[i]].push_back(i);
    for (int i = 1; i < n; i ++)
    {
        int a, b;
        cin >> a >> b;
        g[a].push_back(b);
        g[b].push_back(a);
    }

    int so_far = n;
    for (int i = 1; i <= n; i ++)
    {
        if (col[i].size() > block)
        {
            for (int v : col[i])
                sp.push_back(v);
            ridx[i] = i;
        }
    }

    for (int i = 1; i <= n; i ++)
    {
        if (col[i].size() > block)
        {
        nt = 2;
        dfs(1, -1, 1, i);
        for (int j = 1; j <= n; j ++)
        {
            for (int v : to_calc[j])
                sm[c[v]] ++;
            for (int v : to_calc[j])
            {
                ask[c[v]][ridx[i]] += (sm[c[v]] * (sm[c[v]] - 1) / 2);
                sm[c[v]] = 0;
            }
            to_calc[j].clear();
        }
        }
    }


    euler(1, -1);
    build_sparse_table();

    for (int i = 1; i <= n; i ++)
        cp[c[i]].push_back({in[i], out[i]});

    for (int i = 1; i <= n; i ++)
    {
        sort(cp[i].begin(), cp[i].end());
        if (cp[i].size() > 0)
            mst[i].build_mst(cp[i]);
    }


    /**for (int i = 1; i <= n; i ++)
        cout << i << " " << c[i] << " " << in[i] << " " << out[i] << endl;
    for (pair < int, int >  pr : mst[1].tree[1])
    {
        cout << pr.first << " : " << pr.second << endl;
    }*/

    cin >> q;
    for (int i = 1; i <= q; i ++)
    {
        int x, y;
        cin >> x >> y;

        if (col[x].size() <= block)
        {
            for (int ver : col[x])
            {

                int dw = -1;
                if (cp[y].size() > 0)
                {
                    int lf = 0, rf = (int)cp[y].size() - 1;
                    while(lf <= rf)
                    {
                        int mf = (lf + rf) / 2;
                        if (cp[y][mf].first > in[ver])
                            rf = mf - 1;
                        else
                            lf = mf + 1;
                    }
                    ///cout << "START" << endl;
                    if (rf >= 0)
                    dw = mst[y].query(1, 0, (int)mst[y].seg.size() - 1, 0, rf, out[ver]);
                }

                ///cout << ver << " : " << dw << endl;
                closest[ver] = dw;
            }


            int cur_ans = 0;

            for (int id1 = 0; id1 < col[x].size(); id1 ++)
                for (int id2 = id1; id2 < col[x].size(); id2 ++)
                {
                    int v1 = col[x][id1], v2 = col[x][id2];
                    int lca = find_lca(v1, v2);
                    if (lvl[lca] <= closest[v1] || lvl[lca] <= closest[v2])
                    {
                        cur_ans ++;
                    }
                }

            cout << cur_ans << endl;
        }
        else
        {

            cout << col[x].size() * (col[x].size() - 1) / 2 - ask[x][ridx[y]] << endl;
        }

    }

}

int main()
{
    speed();
    solve();
    return 0;
}
