template <uint N>
struct ZeroArray
{
    uint vals[N];

    constexpr ZeroArray(): vals()
    {
        for (uint j = 0; j < N; ++j)
        {
            vals[j] = 0;
        }
    }
};

struct InitializedArray
{
    uint vals[1000];

    constexpr InitializedArray(): vals()
    {
        for (uint j = 0; j < 1000; ++j)
        {
            vals[j] = j * 3;
        }
    }
};

constexpr InitializedArray globArr;

constexpr uint stateSize(uint n)
{
    return 7;
}

constexpr void processOne(uint n, uint i, uint curr, State& state)
{
    if(i%8 == 0) state[0]++;
    else
    if(i%8 == 1) state[1]++;
    else
    if(i%8 == 2) state[2]++;
    else
    if(i%8 == 3) state[3]++;
    else
    if(i%8 == 4) state[4]++;
    else
    if(i%8 == 5) state[5]++;
    else
    if(i%8 == 6) state[6]++;
    else
    if(i%8 == 7) state[7]++;
   // if (i % 3 != 0) state[1] += globArr.vals[state[0]];
}

constexpr uint getAnswer(uint n, const State& state)
{
    int ans = 0;
    for (uint i = 0; i < 8; ++i)
    {
        ans+= state[i]*state[i];
    }
    return ans;
}
