template <uint N>
struct ZeroArray
{
    uint vals[N];

    constexpr ZeroArray(): vals()
    {
        for (uint j = 0; j < N; ++j)
        {
            vals[j] = 0;
        }
    }
};

struct InitializedArray
{
    uint vals[1000];

    constexpr InitializedArray(): vals()
    {
        for (uint j = 0; j < 1000; ++j)
        {
            vals[j] = j * 3;
        }
    }
};

constexpr InitializedArray globArr;

constexpr uint stateSize(uint n)
{
    return 2;
}

constexpr void processOne(uint n, uint i, uint curr, State& state)
{
    if(i%2 == 0) state[0]++;
    else state[1]++;
   // if (i % 3 != 0) state[1] += globArr.vals[state[0]];
}

constexpr uint getAnswer(uint n, const State& state)
{
    int ans = 0;
    for (uint i = 0; i < 2; ++i)
    {
        ans+= state[i]*state[i];
    }
    return ans;
}
