#include<iostream>
#include<algorithm>
#include<vector>
#define endl "\n"
using namespace std;

int const MAXN=100000;
int n, q, color[MAXN], used[MAXN], baned[MAXN], ans = 0;
vector<int> v[MAXN], col[MAXN];

void DFS(int i, int x, int y, bool state)
{
    used[i] = 1;
    int sz = v[i].size();
    for(int j=0;j<sz;j++)
    {
        int nb = v[i][j];
        if(!used[nb])
        {
            used[nb] = 1;
            if(color[nb] == y)
            {
                DFS(nb, x, y, true);
            }
            else if(color[nb] == x && state == true && !baned[nb])
            {
                //cout<<nb<<endl;
                ans++;
                DFS(nb, x, y, state);
            }
            else DFS(nb, x, y, state);
            used[nb] = 0;
        }
    }
}

void read()
{
    int x, y;
    cin>>n;
    for(int i=1;i<=n;i++)
    {
        cin>>color[i];
        col[color[i]].push_back(i);
    }
    for(int i=1;i<n;i++)
    {
        cin>>x>>y;
        v[x].push_back(y);
        v[y].push_back(x);
    }
    cin>>q;
    for(int i=1;i<=q;i++)
    {
        cin>>x>>y;
        int sz = col[x].size();
        if(sz < 2)
        {
            cout<<0<<endl;
        }
        else
        {
            ans = 0;
            for(int i=0;i<sz;i++)
            {
                int ver = col[x][i];
                //cout<<ver<<endl;
                baned[ver] = 1;
                for(int i=1;i<=n;i++)
                {
                    used[i] = 0;
                }
                DFS(ver, x, y, false);
                //cout<<ans<<endl;
            }
            cout<<ans<<endl;
            //cout<<endl;
        }
        for(int i=1;i<=n;i++)
        {
            baned[i] = 0;
        }
    }
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    read();
    return 0;
}
