#include<iostream>
#include<algorithm>
#include<vector>
#define endl "\n"
using namespace std;

int const MAXN=100000;
int n, q, color[MAXN], used[MAXN], col[MAXN], ans = 0, parsum[MAXN];
vector<int> v[MAXN], p, pos[MAXN];

void DFS(int i)
{
    used[i] = 1;
    p.push_back(i);
    int sz = v[i].size();
    for(int j=0;j<sz;j++)
    {
        int nb = v[i][j];
        if(!used[nb])
        {
            DFS(nb);
        }
    }
}

void read()
{
    int x, y;
    cin>>n;
    for(int i=1;i<=n;i++)
    {
        cin>>color[i];
    }
    for(int i=1;i<n;i++)
    {
        cin>>x>>y;
        v[x].push_back(y);
        v[y].push_back(x);
    }
    int start;
    for(int i=1;i<=n;i++)
    {
        if(v[i].size() == 1)
        {
            start = i;
            break;
        }
    }
    DFS(start);
    for(int i=0;i<n;i++)
    {
        col[i+1] = color[p[i]];
        pos[col[i+1]].push_back(i+1);
    }
    cin>>q;
    for(int u=1;u<=q;u++)
    {
        cin>>x>>y;
        ans = 0;
        for(int i=1;i<=n;i++)
        {
            parsum[i] = 0;
        }
        for(int i=1;i<=n;i++)
        {
            parsum[i] += parsum[i-1] + (col[i] == x);
        }
        int prev = 0;
        for(int i=0;i<pos[y].size();i++)
        {
            int now = pos[y][i];
            ans += (parsum[now] - parsum[prev])*(parsum[n] - parsum[now]);
            prev = now;
        }
        cout<<ans<<endl;
    }
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    read();
    return 0;
}

/*
6
3 2 3 1 1 1
5 2
1 6
1 2
4 6
3 4
6
1 2
2 1
1 3
3 1
2 3
3 2
*/
