using uint = unsigned int;
using ull = unsigned long long;
constexpr uint NUM_TESTS = 10000;
constexpr uint MAX_STATE_SIZE = 8;
using State = std::array<uint, MAX_STATE_SIZE>;
constexpr uint stateSize(uint n);
constexpr void processOne(uint n, uint i, int curr, State& state);
constexpr uint getAnswer(uint n, const State& state);

constexpr uint stateSize(uint n)
{
    return 4;
}

constexpr void processOne(uint n, uint i, int curr, State& state)
{
    for(int x=0;x<4;x+=2)
        if(curr==state[x])
        {
            state[x+1]++;
            return;
        }
    for(int x=0;x<4;x+=2)
    {
        if(state[x]==0&&state[x+1]==0)
        {
            state[x]=curr;
            state[x+1]=1;
        }
    }
}

constexpr uint getAnswer(uint n, const State& state)
{
    uint x=max(state[1],state[3]);

    uint y=1000/x;

    return y*x*x;
}