constexpr uint getColour(const State &state)
{
    return (state[0]<<16)>>16;
}
constexpr uint getCount(const State &state)
{
    return state[0]>>16;
}
constexpr void addOne(State &state)
{
    state[0]=getColour(state)+((getCount(state)+1)<<16);
}
constexpr uint stateSize(uint n)
{
    return 1;
}
constexpr void processOne(uint n, uint i, uint curr, State& state)
{
    if(getColour(state)==0)state[0] = curr;
    if(curr==getColour(state))
        addOne(state);
}
constexpr uint getAnswer(uint n, const State& state)
{
    int t=n/getCount(state);
    return t*getCount(state)*getCount(state);
}

/*
4 10
4 4 5 5
*/
