#include<iostream>
#include<vector>
#include<utility>
#include<map>
#include<algorithm>

using namespace std;

const long long N = 8010, inf = 1e18;
long long a[N], w[N][N];

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);

    long long n, k;
    cin >> n >> k;
    for(long long i = 1; i <= n; ++i) cin >> a[i];
    sort(a + 1, a + n + 1);

    //for(int i = 1; i <= n; ++i) cout << a[i] << " ";
    //cout << endl;
    for(long long i = 1; i <= n; ++i)
    {
        w[1][i] = i * a[i];
        for(long long j = 2; j <= min(i, k); ++j)
        {
            w[j][i] = inf;
            for(long long r = i; r >= j; --r)
            {
                w[j][i] = min(w[j][i], (i - r + 1) * a[i] + w[j - 1][r - 1]);
            }
        }
    }
    //for(int i = 1; i <= k; ++i, cout << endl)
    //    for(int j = 1; j <= n; ++j) cout << w[i][j] << " ";
    cout << w[k][n] << endl;
    return 0;
}
