#include<bits/stdc++.h>
using namespace std;

const int nmax=8e4+42;

int n;

int inp[nmax];

vector<int> adj[nmax];

int in[nmax],out[nmax],t;

vector<int> seen[nmax];

map< pair<int,int>, long long> mem;

int x,y;
long long outp;

int up[20][nmax];

int depth[nmax];

bool cmp(int a,int b)
{
    return in[a]<in[b];
}

bool is_parent(int u,int v)
{
    return in[u]<=in[v]&&out[v]<=out[u];
}

int lca(int u,int v)
{
    if(is_parent(u,v))return u;
    if(is_parent(v,u))return v;

    if(depth[u]<depth[v])swap(u,v);

    //depth[u]>=depth[v]

    for(int i=19;i>=0;i--)
        if(depth[u]-(1<<i)>=depth[v])u=up[i][u];

    if(u==v)return u;

    for(int i=19;i>=0;i--)
        if(up[i][u]!=up[i][v])u=up[i][u],v=up[i][v];

    return up[0][u];
}

vector<int> adj_new[nmax];

stack<int> active,idle;

int dfs_eval(int node,int parent)
{
    long long ret=0;

    if(inp[node]==x)ret++;

    for(auto w:adj_new[node])
        if(w!=parent)
        {
            int cur=dfs_eval(w,node);

            if(inp[node]!=y)outp=outp-ret*cur;

            ret+=cur;
        }

    if(inp[node]==y)ret=0;

    return ret;
}

long long query()
{
    scanf("%i%i",&x,&y);

    if(seen[x].size()==0||seen[y].size()==0)return 0;

    if(mem.count({x,y}))return mem[{x,y}];

    outp=seen[x].size();

    outp=outp*(outp-1)/2;

    if(x==y)return outp;

    vector<int> nodes={};

    int pointer_x=0,pointer_y=0;

    while(pointer_x<seen[x].size()&&pointer_y<seen[y].size())
    {
        if(in[seen[x][pointer_x]]<in[seen[y][pointer_y]])
        {
            nodes.push_back(seen[x][pointer_x]);
            pointer_x++;
            continue;
        }

        nodes.push_back(seen[y][pointer_y]);
        pointer_y++;
    }

    while(pointer_x<seen[x].size())
    {
        nodes.push_back(seen[x][pointer_x]);
        pointer_x++;

    }

    while(pointer_y<seen[y].size())
    {
        nodes.push_back(seen[y][pointer_y]);
        pointer_y++;
    }

    for(int i=nodes.size()-1;i>=1;i--)
        nodes.push_back(lca(nodes[i-1],nodes[i]));

    sort(nodes.begin(),nodes.end(),cmp);

    for(auto w:nodes)
        adj_new[w]={};

    //cout<<"nodes= ";for(auto w:nodes)cout<<w<<" ";cout<<endl;

    active=idle;

    active.push(nodes[0]);

    for(auto w:nodes)
        if(active.top()!=w)
        {
            while(is_parent(active.top(),w)==0)active.pop();

            adj_new[active.top()].push_back(w);
            adj_new[w].push_back(active.top());

            active.push(w);
        }

    int ev=dfs_eval(nodes[0],nodes[0]);

    mem[{x,y}]=outp;

    return outp;
}

void dfs(int node,int parent)
{
    depth[node]=depth[parent]+1;

    up[0][node]=parent;

    for(int i=1;i<20;i++)
        up[i][node]=up[i-1][up[i-1][node]];

    t++;

    in[node]=t;

    seen[inp[node]].push_back(node);

    for(auto w:adj[node])
        if(w!=parent)
            dfs(w,node);

    out[node]=t;
}

int main()
{
    scanf("%i",&n);

    for(int i=1;i<=n;i++)scanf("%i",&inp[i]);

    for(int i=1;i<n;i++)
    {
        int u,v;

        scanf("%i%i",&u,&v);

        adj[u].push_back(v);
        adj[v].push_back(u);
    }

    dfs(1,1);

    int q;
    scanf("%i",&q);

    for(int i=1;i<=q;i++)printf("%lld\n",query());

    return 0;
}
