#include<bits/stdc++.h>
using namespace std;

const int nmax=8e4+42;

int n;

int inp[nmax];

vector<int> adj[nmax];

int in[nmax],out[nmax],t;

vector<int> seen[nmax];

map< pair<int,int>, long long> mem;

int x,y;
long long outp;

int depth[nmax];

bool cmp(int a,int b)
{
    return in[a]<in[b];
}

bool is_parent(int u,int v)
{
    return in[u]<=in[v]&&out[v]<=out[u];
}

pair<int,int> given[2*nmax];

pair<int,int> mini[20][2*nmax];

int SZ[2*nmax];

int ask(int lq,int rq)
{
    int d=SZ[rq-lq+1];

    return min(mini[d][lq],mini[d][rq-(1<<d)+1]).second;
}
int lca(int u,int v)
{
    if(is_parent(u,v))return u;
    if(is_parent(v,u))return v;

    return ask(min(in[u],in[v]),max(out[u],out[v]));
}

vector<int> adj_new[nmax];

stack<int> active,idle;

int dfs_eval(int node,int parent)
{
    long long ret=0;

    if(inp[node]==x)ret++;

    for(auto w:adj_new[node])
        if(w!=parent)
        {
            int cur=dfs_eval(w,node);

            if(inp[node]!=y)outp=outp-ret*cur;

            ret+=cur;
        }

    if(inp[node]==y)ret=0;

    return ret;
}

long long query()
{
    scanf("%i%i",&x,&y);

    if(seen[x].size()==0||seen[y].size()==0)return 0;

    if(mem.count({x,y}))return mem[{x,y}];

    outp=seen[x].size();

    outp=outp*(outp-1)/2;

    if(x==y)return outp;

    vector<int> nodes={};

    int pointer_x=0,pointer_y=0;

    while(pointer_x<seen[x].size()&&pointer_y<seen[y].size())
    {
        if(in[seen[x][pointer_x]]<in[seen[y][pointer_y]])
        {
            nodes.push_back(seen[x][pointer_x]);
            pointer_x++;
            continue;
        }

        nodes.push_back(seen[y][pointer_y]);
        pointer_y++;
    }

    while(pointer_x<seen[x].size())
    {
        nodes.push_back(seen[x][pointer_x]);
        pointer_x++;

    }

    while(pointer_y<seen[y].size())
    {
        nodes.push_back(seen[y][pointer_y]);
        pointer_y++;
    }

    for(int i=nodes.size()-1;i>=1;i--)
        nodes.push_back(lca(nodes[i-1],nodes[i]));

    sort(nodes.begin(),nodes.end(),cmp);

    for(auto w:nodes)
        adj_new[w]={};

    //cout<<"nodes= ";for(auto w:nodes)cout<<w<<" ";cout<<endl;

    active=idle;

    active.push(nodes[0]);

    for(auto w:nodes)
        if(active.top()!=w)
        {
            while(is_parent(active.top(),w)==0)active.pop();

            adj_new[active.top()].push_back(w);
            adj_new[w].push_back(active.top());

            active.push(w);
        }

    int ev=dfs_eval(nodes[0],nodes[0]);

    mem[{x,y}]=outp;

    return outp;
}

void dfs(int node,int parent)
{
    depth[node]=depth[parent]+1;

    t++;

    in[node]=t;

    given[t]={depth[node],node};

    seen[inp[node]].push_back(node);

    for(auto w:adj[node])
        if(w!=parent)
        {
            dfs(w,node);

            t++;
            given[t]={depth[node],node};
        }

    out[node]=t;
}

int main()
{
    scanf("%i",&n);

    for(int i=1;i<=n;i++)scanf("%i",&inp[i]);

    for(int i=1;i<n;i++)
    {
        int u,v;

        scanf("%i%i",&u,&v);

        adj[u].push_back(v);
        adj[v].push_back(u);
    }

    dfs(1,1);

    for(int j=1;j<=t;j++)mini[0][j]=given[j];

    for(int p=1;(1<<p)<=t;p++)
        for(int i=1;(1<<p)+i-1<=t;i++)
            mini[p][i]=min(mini[p-1][i],mini[p-1][i+(1<<(p-1))]);

    for(int i=2;i<=t;i++)
        SZ[i]=SZ[i/2]+1;

    int q;
    scanf("%i",&q);

    for(int i=1;i<=q;i++)printf("%lld\n",query());

    return 0;
}
