#include<bits/stdc++.h>
using namespace std;

const int nmax=8e4+42,C=50;

int n;

int inp[nmax];

vector<int> adj[nmax];

int in[nmax],out[nmax],t;
int up[20][nmax];

int jump(int node,int d)
{
    for(int i=19;i>=0;i--)
        if((d&(1<<i)))node=up[i][node];

    return node;
}

vector<int> seen[nmax];

map< pair<int,int>, long long> mem;

long long mem_big[C+42][nmax];
int cnt_big[C+42][nmax];

int where_in_big[nmax];

int x,y;
long long outp;

int depth[nmax];

bool cmp(int a,int b)
{
    return in[a]<in[b];
}

bool is_parent(int u,int v)
{
    return in[u]<=in[v]&&out[v]<=out[u];
}

pair<int,int> given[2*nmax];

pair<int,int> mini[20][2*nmax];

int SZ[2*nmax];

int ask(int lq,int rq)
{
    int d=SZ[rq-lq+1];

    return min(mini[d][lq],mini[d][rq-(1<<d)+1]).second;
}
int lca(int u,int v)
{
    if(is_parent(u,v))return u;
    if(is_parent(v,u))return v;

    return ask(min(in[u],in[v]),max(out[u],out[v]));
}

vector<int> adj_new[nmax];

stack<int> active,idle;

int dfs_eval(int node,int parent)
{
    long long ret=0;

    if(inp[node]==x)ret++;

    for(auto w:adj_new[node])
        if(w!=parent)
        {
            int cur=dfs_eval(w,node);

            if(inp[node]!=y)outp=outp-ret*cur;

            ret+=cur;
        }

    if(inp[node]==y)ret=0;

    return ret;
}

long long slower()
{
    outp=seen[x].size();

    outp=outp*(outp-1)/2;

    if(x==y)return outp;

    vector<int> nodes={};

    int pointer_x=0,pointer_y=0;

    while(pointer_x<seen[x].size()&&pointer_y<seen[y].size())
    {
        if(in[seen[x][pointer_x]]<in[seen[y][pointer_y]])
        {
            nodes.push_back(seen[x][pointer_x]);
            pointer_x++;
            continue;
        }

        nodes.push_back(seen[y][pointer_y]);
        pointer_y++;
    }

    while(pointer_x<seen[x].size())
    {
        nodes.push_back(seen[x][pointer_x]);
        pointer_x++;

    }

    while(pointer_y<seen[y].size())
    {
        nodes.push_back(seen[y][pointer_y]);
        pointer_y++;
    }

    for(int i=nodes.size()-1;i>=1;i--)
        nodes.push_back(lca(nodes[i-1],nodes[i]));

    sort(nodes.begin(),nodes.end(),cmp);

    for(auto w:nodes)
        adj_new[w]={};

    //cout<<"nodes= ";for(auto w:nodes)cout<<w<<" ";cout<<endl;

    active=idle;

    active.push(nodes[0]);

    for(auto w:nodes)
        if(active.top()!=w)
        {
            while(is_parent(active.top(),w)==0)active.pop();

            adj_new[active.top()].push_back(w);
            adj_new[w].push_back(active.top());

            active.push(w);
        }

    int ev=dfs_eval(nodes[0],nodes[0]);

    mem[{x,y}]=outp;

    return outp;
}

long long query()
{
    scanf("%i%i",&x,&y);

    if(seen[x].size()==0||seen[y].size()==0)return 0;

    if(mem.count({x,y}))return mem[{x,y}];

    if(where_in_big[x])
    {
        /*
        cout<<"!!! "<<x<<" is big"<<endl;

        cout<<slower()<<" "<<mem_big[where_in_big[x]][y]<<endl;

        assert(slower()==mem_big[where_in_big[x]][y]);
        */

        return mem_big[where_in_big[x]][y];
    }

    return slower();
}

void dfs(int node,int parent)
{
    up[0][node]=parent;
    for(int j=1;j<20;j++)
        up[j][node]=up[j-1][up[j-1][node]];

    //cout<<"node= "<<node<<" up= ";for(int j=0;j<20;j++)cout<<up[j][node]<<" ";cout<<endl;

    depth[node]=depth[parent]+1;

    t++;

    in[node]=t;

    given[t]={depth[node],node};

    seen[inp[node]].push_back(node);

    for(auto w:adj[node])
        if(w!=parent)
        {
            dfs(w,node);

            t++;
            given[t]={depth[node],node};
        }

    out[node]=t;
}

int id_big;

void dfs_cnt(int node,int parent,int colour)
{
    if(inp[node]==colour)cnt_big[id_big][node]++;

    for(auto w:adj[node])
        if(w!=parent)
        {
            dfs_cnt(w,node,colour);

            cnt_big[id_big][node]+=cnt_big[id_big][w];
        }
}

int X_NOW;

int ROOT;

int dfs_down(int node,int parent,int j,int y)
{
    map<int,int> there={};

    for(auto w:adj[node])
        if(is_parent(node,w))
            there[w]+=cnt_big[j][w];

    for(auto w:adj_new[node])
        if(w!=parent)
        {
            int cur=dfs_down(w,node,j,y);

            int v=jump(w,depth[w]-depth[node]-1);

            //cout<<"jump "<<w<<" "<<depth[w]-depth[node]-1<<" is "<<v<<endl;

            there[v]=there[v]-cnt_big[j][w]+cur;
        }

    //cout<<"node= "<<node<<" j= "<<j<<" y= "<<y<<" there= ";for(auto w:there)cout<<w.first<<" "<<w.second<<"\t";cout<<endl;

    long long ret=0;

    if(inp[node]==y)
    {
        ret=0;

        for(auto w:there)
            mem_big[j][y]-=1LL*w.second*(w.second-1)/2;
    }
    else
    {
        if(where_in_big[inp[node]]==j)ret++;

        for(auto w:there)ret+=w.second;

        if(node==ROOT)mem_big[j][y]-=1LL*ret*(ret-1)/2;
    }

    return ret;
}

void calc_big()
{
    id_big=0;

    for(int i=1;i<=n;i++)
        if(seen[i].size()>n/C)
        {
            id_big++;

            where_in_big[i]=id_big;

            cnt_big[id_big][0]=i;

            dfs_cnt(ROOT,ROOT,i);
        }

    for(int y=1;y<=n;y++)
        if(seen[y].size())
        {
            vector<int> nodes={};

            nodes.push_back(ROOT);

            for(auto w:seen[y])
                nodes.push_back(w);

            sort(nodes.begin(),nodes.end(),cmp);

            for(int i=nodes.size()-1;i>=1;i--)
                nodes.push_back(lca(nodes[i-1],nodes[i]));

            sort(nodes.begin(),nodes.end(),cmp);

            for(auto w:nodes)
                adj_new[w]={};

            active=idle;

            active.push(nodes[0]);

            for(auto w:nodes)
                if(active.top()!=w)
                {
                    while(is_parent(active.top(),w)==0)active.pop();

                    adj_new[active.top()].push_back(w);
                    adj_new[w].push_back(active.top());

                    active.push(w);
                }

            for(int j=1;j<=id_big;j++)
            {
                X_NOW=cnt_big[j][0];

                if(X_NOW==y)continue;

                mem_big[j][y]=1LL*seen[X_NOW].size()*(seen[X_NOW].size()-1)/2;

                int dwn=dfs_down(nodes[0],nodes[0],j,y);

                //cout<<"---"<<endl;
            }
        }

}

mt19937 rng(42);

int main()
{
    scanf("%i",&n);
    //n=10;

    for(int i=1;i<=n;i++)scanf("%i",&inp[i]);

    /*
    for(int i=1;i<=n;i++)inp[i]=rng()%3+1;

    for(int i=1;i<=n;i++)cout<<inp[i]<<" ";cout<<endl;
    */

    for(int i=1;i<n;i++)
    {
        int u,v;

        scanf("%i%i",&u,&v);
        /*
        u=i+1;
        v=rng()%i+1;

        cout<<u<<" "<<v<<endl;
        */

        adj[u].push_back(v);
        adj[v].push_back(u);
    }

    ROOT=1;
    for(int i=2;i<=n;i++)
        if(adj[ROOT].size()>adj[i].size())ROOT=i;

    dfs(ROOT,ROOT);

    //cout<<"ROOT= "<<ROOT<<endl;

    for(int j=1;j<=t;j++)mini[0][j]=given[j];

    for(int p=1;(1<<p)<=t;p++)
        for(int i=1;(1<<p)+i-1<=t;i++)
            mini[p][i]=min(mini[p-1][i],mini[p-1][i+(1<<(p-1))]);

    for(int i=2;i<=t;i++)
        SZ[i]=SZ[i/2]+1;

    calc_big();

    int q;
    scanf("%i",&q);

    for(int i=1;i<=q;i++)printf("%lld\n",query());

    return 0;
}
