
constexpr uint stateSize(uint n)
{
    return 3;
}

constexpr void processOne(uint n, uint i, uint curr, State& state)
{
    if (i == 0){
        state [0] = curr;
        state [1] = state [2] = (1 << 16) - 1;
    }
    if (curr == state [0] % (1 << 16)){
        state [0] += (1 << 16);
        return;
    }
    if (state [1] == (1 << 16) - 1) state [1] = curr;
    if (curr == state [1] % (1 << 16)){
        state [1] += (1 << 16);
        return;
    }
    if (state [2] == (1 << 16) - 1) state [2] = curr;
    if (curr == state [2] % (1 << 16)){
        state [2] += (1 << 16);
        return;
    }
}

constexpr uint getAnswer(uint n, const State& state)
{
    uint res1 = n * (state [0] >> 16);
    uint res2 = n * (state [1] >> 16);
    uint res3 = n * (state [2] >> 16);
    if (res2 == 0) res2 = res1;
    if (res3 == 0) res3 = (res1 + res2) / 2;
    return (res1 + res2 + res3) / 3;
}
