#include <bits/stdc++.h>
using namespace std;

const int maxn = 1000006;
int n, k;
long long a [maxn];
struct str{
    long double first, second;
    int cuts;
};
vector <str> v;
int idx;

int main (){

    ios::sync_with_stdio (false);
    cin.tie (0);

    cin >> n >> k;
    for (int i = 0; i < n; i ++){
        cin >> a [i];
    }
    sort (a, a + n);

    int k1 = 1;
    for (int i = 1; i < n; i ++) if (a [i] != a [i - 1]) k1 ++;
    if (k1 <= k){
        long long sum = 0;
        for (int i = 0; i < n; i ++) sum += a [i];
        cout << sum << '\n';
        return 0;
    }

    long double l = -1, r = 10000000000000000000;
    while (l < r){
        long double mid = (l + r) / 2.0;
        v.clear ();
        idx = 0;
        v.push_back ({0, 0, 0});
        for (int i = 0; i < n; i ++){
            long double val = v [idx].first - v [idx].second * a [i];
            while (idx < v.size () - 1){
                long double val2 = v [idx + 1].first - v [idx + 1].second * a [i];
                if (val2 > val) break;
                idx ++;
                val = val2;
            }
            str p = {val + (i + 1) * a [i] + mid, i + 1, v [idx].cuts + 1};
            while (v.size () > 1){
                auto p1 = v.back (), p2 = v [v.size () - 2];
                long double x1 = (p.first - p1.first) / (p.second - p1.second);
                long double x2 = (p1.first - p2.first) / (p1.second - p2.second);
                if (x1 <= x2) v.pop_back ();
                else break;
            }
            v.push_back (p);
            if (idx >= v.size ()) idx = v.size () - 1;
        }
        int c = v.back ().cuts;
        if (c == k){
            cout << (long long) round (v.back ().first - c * mid) << '\n';
            return 0;
        }
        else if (c < k) r = mid;
        else l = mid;
    }

}
/*
10000000000
10 4
100000000004 100000000001 100000000012 100000000017 100000000007 100000000003 100000000006 100000000008 100000000010 100000000016
*/
