#include <bits/stdc++.h>
using namespace std;
#ifdef EVAL
#define cerr if(false)cerr
#endif // EVAL
#define endl "\n"
typedef long long ll;
const ll mod = 1e9 + 7;
template<class T, class T2> bool chkmin(T &a, const T2 &b) { return (a > b) ? a = b, 1: 0;}
template<class T, class T2> bool chkmax(T &a, const T2 &b) { return (a < b) ? a = b, 1: 0;}

const int MAX_N = 1e5 + 10;
int n, q;
vector<int> g[MAX_N];
int col[MAX_N];
vector<int> who[MAX_N];
vector<pair<int, int> > quer[MAX_N];

ll cnt[MAX_N], total[MAX_N], sum[MAX_N];
vector<int> cntVec, totalVec, sumVec;

int ans[MAX_N];
bool used[MAX_N];

void dfs(int x, int p, int c) {
    if(used[x] || col[x] == c) {
        cerr << "Ret " << x << endl;
        return;
    }
    cnt[col[x]] ++;
    sum[col[x]] += total[col[x]];
    used[x] = true;
    cerr << "Got for " << x << " " << col[x] << " " << cnt[col[x]] << " " << total[col[x]] << " " << sum[col[x]] << endl;
    cntVec.push_back(col[x]);
    sumVec.push_back(col[x]);
    for(auto it : g[x]) {
        if(it == p) {continue;}
        dfs(it, x, c);
    }
}

void solve_big(int c) {
    for(int i = 1; i <= n; i ++) {
        used[i] = false;
    }

    cerr << "Solving for color " << c << endl;

    for(int i = 1; i <= n; i ++) {
        if(!used[i]) {
            dfs(i, -1, c);
            for(const auto &it : cntVec) {
                total[it] += cnt[it];
                cnt[it] = 0;
                totalVec.push_back(it);
            }

            cerr << "DEBUGGING" << endl;
            for(int it = 1; it <= n; it ++) {
                cerr << cnt[it] << " " << total[it] << " " << sum[it] << endl;
            }
            cerr << "ENDING" << endl;
            cntVec.resize(0);
        }
    }

    for(auto it : quer[c]) {
        ans[it.second] = sum[it.first];
    }

    for(const auto &it : totalVec) {
        total[it] = 0;
    }
    totalVec.resize(0);
    for(const auto &it : sumVec) {
        sum[it] = 0;
    }
    sumVec.resize(0);
    cerr << "DEBUGGING" << endl;
    for(int it = 1; it <= n; it ++) {
        cerr << cnt[it] << " " << total[it] << " " << sum[it] << endl;
    }
    cerr << "ENDING" << endl;
}

signed main() {
#ifdef EVAL
    ios_base::sync_with_stdio(false); cin.tie(NULL);
#endif // EVAL

    cin >> n;
    for(int i = 1; i <= n; i ++) {
        cin >> col[i];
        who[col[i]].push_back(i);
    }
    for(int i = 0; i < n - 1; i ++) {
        int a, b;
        cin >> a >> b;
        g[a].push_back(b);
        g[b].push_back(a);
    }

    cin >> q;
    for(int i = 0; i < q; i ++) {
        int x, y;
        cin >> x >> y;
        quer[y].push_back({x, i});
    }

    for(int i = 1; i <= n; i ++) {
        solve_big(i);
    }

    for(int i = 0; i < q; i ++) {
        cout << ans[i] << endl;
    }

    return 0;
}

