#include <bits/stdc++.h>
using namespace std;
#ifdef EVAL
#define cerr if(false)cerr
#endif // EVAL
#define endl "\n"
typedef long long ll;
const ll mod = 1e9 + 7;
template<class T, class T2> bool chkmin(T &a, const T2 &b) { return (a > b) ? a = b, 1: 0;}
template<class T, class T2> bool chkmax(T &a, const T2 &b) { return (a < b) ? a = b, 1: 0;}

const int MAX_N = 1e5 + 10, LOG = 17;
int n, q;
vector<int> g[MAX_N];
int col[MAX_N];
vector<int> who[MAX_N];
vector<pair<int, int> > quer[MAX_N], toApply[MAX_N];

ll cnt[MAX_N], total[MAX_N], sum[MAX_N];
vector<int> cntVec, totalVec, sumVec;

int ans[MAX_N];
bool used[MAX_N];

void dfs(int x, int p, int c) {
    if(used[x] || col[x] == c) {
        cerr << "Ret " << x << endl;
        return;
    }
    cnt[col[x]] ++;
    sum[col[x]] += total[col[x]];
    used[x] = true;
    cerr << "Got for " << x << " " << col[x] << " " << cnt[col[x]] << " " << total[col[x]] << " " << sum[col[x]] << endl;
    cntVec.push_back(col[x]);
    sumVec.push_back(col[x]);
    for(auto it : g[x]) {
        if(it == p) {continue;}
        dfs(it, x, c);
    }
}

void solve_big(int c) {
    for(int i = 1; i <= n; i ++) {
        used[i] = false;
    }

    cerr << "Solving for color " << c << endl;

    for(int i = 1; i <= n; i ++) {
        if(!used[i]) {
            dfs(i, -1, c);
            for(const auto &it : cntVec) {
                total[it] += cnt[it];
                cnt[it] = 0;
                totalVec.push_back(it);
            }

            cerr << "DEBUGGING" << endl;
            for(int it = 1; it <= n; it ++) {
                cerr << cnt[it] << " " << total[it] << " " << sum[it] << endl;
            }
            cerr << "ENDING" << endl;
            cntVec.resize(0);
        }
    }

    for(auto it : quer[c]) {
        ans[it.second] = sum[it.first];
    }

    for(const auto &it : totalVec) {
        total[it] = 0;
    }
    totalVec.resize(0);
    for(const auto &it : sumVec) {
        sum[it] = 0;
    }
    sumVec.resize(0);
    cerr << "DEBUGGING" << endl;
    for(int it = 1; it <= n; it ++) {
        cerr << cnt[it] << " " << total[it] << " " << sum[it] << endl;
    }
    cerr << "ENDING" << endl;
}

int in[MAX_N], out[MAX_N], tme = -1;
int jump[MAX_N][LOG];
int d[MAX_N];

void pre(int x, int p) {
    in[x] = ++ tme;
    d[x] = d[p] + 1;
    jump[x][0] = p;
    for(int i = 1; i < LOG; i ++) {
        jump[x][i] = jump[jump[x][i - 1]][i - 1];
    }

    for(const auto &it : g[x]) {
        if(it == p) {continue;}
        pre(it, x);
    }
    out[x] = tme;
}

int jump_to(int a, int k) {
    for(int i = LOG - 1; i >= 0; i --) {
        if(d[jump[a][i]] >= k) {
            a = jump[a][i];
        }
    }
    return a;
}

int lca(int a, int b) {
    if(d[a] < d[b]) {swap(a, b);}

    jump_to(a, d[b]);
    if(a == b) {return a;}

    for(int i = LOG - 1; i >= 0; i --) {
        if(jump[a][i] != jump[b][i]) {
            a = jump[a][i];
            b = jump[b][i];
        }
    }

    return jump[a][0];
}

int par[MAX_N];
vector<int> allPars[MAX_N];
bool isPar[MAX_N];

void solve_small(int c) {
    sort(who[c].begin(), who[c].end());
}

struct SegTree {
    int tree[4 * MAX_N];

    void upd(int curr, int l, int r, int ind, int val) {
        if(l == r && l == ind) {
            tree[curr] += val;
            return;
        } else if(l > ind || r < ind) {
            return;
        }
        int m = (l + r) / 2ll;
        upd(curr * 2, l, m, ind, val);
        upd(curr * 2 + 1, m + 1, r, ind, val);
        tree[curr] = tree[curr * 2] + tree[curr * 2 + 1];
    }

    ll sum(int curr, int l, int r, int ql, int qr) {
        if(ql <= l && r <= qr) {
            return tree[curr];
        } else if(l > qr || r < ql) {
            return 0;
        }
        int m = (l + r) / 2ll;
        return sum(curr * 2, l, m, ql, qr) + sum(curr * 2 + 1, m + 1, r, ql, qr);
    }
};

SegTree st, bad;

ll dp[MAX_N];

vector<int> aux[MAX_N];
ll sz[MAX_N], what[MAX_N];

void apply_small(int c) {
    if(toApply[c].size() == 0) {return;}
    for(const auto it : who[c]) { st.upd(1, 0, MAX_N - 1, in[it], 1); }

    for(const auto &it : toApply[c]) {
        ll total = who[c].size();

        for(int i = 0; i < who[it.first].size() - 1; i ++) {
            ll now = st.sum(1, 0, MAX_N - 1, who[it.first][i], who[it.first][i + 1]);
            ans[it.second] += now * (total - now);
        }
        ll now1 = st.sum(1, 0, MAX_N - 1, 0, who[it.first][0]);
        ans[it.second] += now1 * (total - now1);
        ll now2 = st.sum(1, 0, MAX_N - 1, who[c].back(), tme + 1);
        ans[it.second] += now2 * (total - now2);
    }

    for(const auto it : who[c]) { st.upd(1, 0, MAX_N - 1, in[it], -1); }
    return;
}

signed main() {
#ifdef EVAL
    ios_base::sync_with_stdio(false); cin.tie(NULL);
#endif // EVAL

    cin >> n;
    for(int i = 1; i <= n; i ++) {
        cin >> col[i];
        who[col[i]].push_back(i);
    }
    g[0].push_back(1);
    for(int i = 0; i < n - 1; i ++) {
        int a, b;
        cin >> a >> b;
        g[a].push_back(b);
        g[b].push_back(a);
    }

    cin >> q;
    for(int i = 0; i < q; i ++) {
        int x, y;
        cin >> x >> y;
        quer[y].push_back({x, i});
    }

    const int BLOCK = 100;

    for(int i = 1; i <= n; i ++) {
        if(who[i].size() <= BLOCK) {
            solve_small(i);
        } else {
            solve_big(i);
        }
    }

    for(int i = 1; i <= n; i ++) {
        apply_small(i);
    }

    for(int i = 0; i < q; i ++) {
        cout << ans[i] << endl;
    }

    return 0;
}

