constexpr uint stateSize(uint n)
{
    return 7;
}

struct boolArray
{
    bool c[256];
    constexpr boolArray(): c()
    {
        for (uint j = 0; j < 256; ++j)
        {
            c[j] = 0;
        }
    }
};

constexpr int a[12] = {2, 3, 5, 7, 11, 13, 17, 19, 23, 29, 31, 37};
struct Rems
{
    bool bits[480];
    constexpr Rems(): bits()
    {
        for (uint j = 0; j < 12 ; ++j)
        {
            for (uint i = 0 ; i < 40 ; ++i)
            {
                bits[j*40+i] = 0;
            }
        }
    }
};

constexpr void processOne(uint n, uint i, uint curr, State& state)
{
    int diff = 0;
    int ans = 0;
    boolArray c;
    for (int i = 0 ; i < 8 ; ++i)
    {
        for (int j = 0 ; j < 32 ; ++j)
        {
            c.c[i*32+j] = state[i] & (1 << 31-j);
        }
    }

    for (int i = 19 ; i >= 0 ; --i)
    {
        ans += c.c[i];
        ans *= 2;
    }

    for (int i = 29 ; i >= 20 ; --i)
    {
        diff += c.c[i];
    }

    Rems rems;
    int where = 0;
    int whereBit = 0;
    for (int i = 30 ; where < 12 ; ++i)
    {
        if (whereBit == a[where])
        {
            whereBit = 0;
            ++where;
        }

        rems.bits[40*where+whereBit] = c.c[i];
        ++whereBit;
    }

    bool missing = false;
    for (int i = 0 ; i < 12 ; ++i)
    {
        if (!rems.bits[i*40+curr%i]) missing = true;
        rems.bits[i*40+curr%i] = true;
    }

    if (missing) ans += i-1;
    else ans += diff-1;

    where = 0;
    whereBit = 0;
    for (int i = 0 ; i < 20 ; ++i)
    {
        if (whereBit == 8)
        {
            whereBit = 0;
            ++where;
        }
        state[where] += (1 << 7-whereBit) * ((ans & (1 << 19-i)) >= 1);
    }

    for (int i = 0 ; i < 10 ; ++i)
    {
        if (whereBit == 8)
        {
            whereBit = 0;
            ++where;
        }
        state[where] += (1 << 7-whereBit) * ((diff & (1 << 9-i)) >= 1);
    }

    for (int i = 0 ; i < 12 ; ++i)
    {
        for (int j = 0 ; j < a[i] ; ++j)
        {
            if (whereBit == 8)
            {
                whereBit = 0;
                ++where;
            }
            state[where] += (1 << 7-whereBit) * rems.bits[i*40+j];
        }
    }
}

constexpr uint getAnswer(uint n, const State& state)
{
    boolArray c;
    for (int i = 0 ; i < 8 ; ++i)
    {
        for (int j = 0 ; j < 32 ; ++j)
        {
            c.c[i*32+j] = state[i] & (1 << 31-j);
        }
    }

    int ans = 0;
    for (int i = 19 ; i >= 0 ; --i)
    {
        ans += c.c[i];
        ans *= 2;
    }

    return 1000000-ans;
}