#include <bits/stdc++.h>
using namespace std;
const int maxn = 100001;
int n,q;
int color[maxn];
vector<int>v[maxn];
int lvl[maxn];///
int tin[maxn];///
int path[maxn];///
int parent[maxn];
int path_lvl[maxn];///
int timer = 0;
int used[maxn];
int tree[maxn*4];
vector<int>c[maxn];
void make_tree( int i, int l, int r )
{
    if( l == r )
    {
        tree[i] = l;
        return;
    }
    int m = ( l + r ) / 2;
    make_tree(i*2,l,m);
    make_tree(i*2+1,m+1,r);
    if( path_lvl[tree[i*2]] <= path_lvl[tree[i*2+1]] ) tree[i] = tree[i*2];
    else tree[i] = tree[i*2+1];
    return;
}
int query( int i, int l, int r, int ql, int qr )
{
    if( l == ql && r == qr ) return tree[i];
    int m = ( l + r ) / 2;
    if( qr <= m ) return query(i*2,l,m,ql,qr);
    else if( ql > m ) return query(i*2+1,m+1,r,ql,qr);
    else
    {
        int x = query(i*2,l,m,ql,m);
        int y = query(i*2+1,m+1,r,m+1,qr);
        if( path_lvl[x] <= path_lvl[y] ) return x;
        else return y;
    }
}
void dfs( int w )
{
    used[w] = 1;
    timer += 1;
    tin[w] = timer;
    path[timer] = w;
    path_lvl[timer] = lvl[w];
    int sz = v[w].size();
    for( int i = 0; i < sz; i ++ )
    {
        int nb = v[w][i];
        if( used[nb] == 0 )
        {
            lvl[nb] = lvl[w] + 1;
            parent[nb] = w;
            dfs(nb);
            timer += 1;
            path[timer] = w;
            path_lvl[timer] = lvl[w];
        }
    }
    return;
}
void read()
{
    cin >> n;
    for( int i = 1; i <= n; i ++ )
    {
        cin >> color[i];
        c[ color[i] ].push_back(i);
    }

    for( int i = 1; i < n; i ++ )
    {
        int x,y;
        cin >> x >> y;
        v[x].push_back(y);
        v[y].push_back(x);
    }
}
int check( int nb, int lca, int y )
{
    while( nb != lca )
    {
        nb = parent[nb];
        if( color[nb] == y ) return 1;
    }
    return 0;
}
void solve( int x, int y )
{
    int ans = 0;
    int sz = c[x].size();
    for( int i = 0; i < sz; i ++ )
    {
        for( int j = i + 1 ; j < sz; j ++ )
        {
            int nb1 = c[x][i];
            int nb2 = c[x][j];
            //cout << nb1 << " " << nb2 << endl;
            int lca = path[query( 1, 1, timer, min( tin[nb1] , tin[nb2] ) , max( tin[nb1] , tin[nb2] ) )];
            //cout << lca << endl;

            bool lamp1 = check(nb1,lca,y);
            bool lamp2 = check(nb2,lca,y);

            if( lamp1 + lamp2 >= 1 )  ans += 1;

        }
    }
    //cout << " -------- " << endl;
    cout << ans << '\n';
}
void read_query()
{
    cin >> q;
    for( int i = 1; i <= q; i ++ )
    {
        int x,y;
        cin >> x >> y;
        solve(x,y);
    }
}
void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
}
int main()
{
    speed();
    read();
    lvl[1] = 1;
    parent[1] = 1;
    dfs(1);
    make_tree(1,1,timer);
    read_query();
    return 0;
}

